Developer Documentation

Public Slots | Signals | Public Member Functions | Private Slots | Private Member Functions | Private Attributes | List of all members
TypeBSplineSurfacePlugin Class Reference
Inheritance diagram for TypeBSplineSurfacePlugin:

## Public Slots
QString | version ()

## Signals
void | log (Logtype _type, QString _message)
void | log (QString _message)
void | emptyObjectAdded (int _id)
void | addContextMenuItem (QAction *_action, ContextMenuType _type)
void | addContextMenuItem (QAction *_action, DataType _objectType, ContextMenuType _type)
Signals inherited from BaseInterface
virtual void | updateView ()
| Update current view in Main Application. More...
virtual void | setSlotDescription (QString _slotName, QString _slotDescription, QStringList _parameters, QStringList _descriptions)
| Set a description for a public slot. More...
virtual void | setRenderer (unsigned int _viewer, QString _rendererName)
| Set a renderer for the given viewer. More...
Signals inherited from TypeInterface
virtual void | emptyObjectAdded (int _id)
| Emit this signal if an empty object has been created. More...
Signals inherited from LoggingInterface
virtual void | log (Logtype _type, QString _message)=0
virtual void | log (QString _message)=0
Signals inherited from LoadSaveInterface
virtual void | save (int _id, QString _filename)
| Save object to a file. More...
virtual void | load (QString _filename, DataType _type, int &_id)
| Load object from file with a specific DataType. More...
Signals inherited from ContextMenuInterface
virtual void | addContextMenuItem (QAction *_action, ContextMenuType _type)
| Add an entry for a context Menu. More...

## Public Member Functions
QString | name ()
| Return a name for the plugin. More...
QString | description ()
| Return a description of what the plugin is doing. More...
bool | registerType ()
DataType | supportedType ()
| Return your supported object type( e.g. DATA_TRIANGLE_MESH ) More...
int | addEmpty ()
| Create an empty object. More...

## Private Slots
void | pluginsInitialized ()
| Second initialization phase. More...
void | noguiSupported ()
void | slotRenderControlNet ()
| Slot triggered from context menu, if the control net should be rendered.
void | slotRenderSurface ()
| Slot triggered from context menu, if the surface should be rendered.
void | slotRenderSelection (QAction *_action)
| Slot triggered from context menu, if the selection rendering should be altered.
Private Slots inherited from BaseInterface
virtual void | exit ()
virtual QString | version ()
| Return a version string for your plugin. More...
Private Slots inherited from TypeInterface
virtual void | generateBackup (int _id, QString _name, UpdateType _type)
| This slot should be implemented in a TypePlugin to generate type specific backups. More...

## Private Member Functions
void | slotUpdateContextMenu (int _objectId)
Private Member Functions inherited from BaseInterface
virtual void | noguiSupported ()
virtual | ~BaseInterface ()
| Destructor.
virtual void | blockScenegraphUpdates (bool _block)
| Tell the core to prevent scenegraph updates. More...
virtual void | updatedObject (int _objectId)
| An object has been changed or added by this plugin. More...
virtual void | updatedObject (int _identifier, const UpdateType &_type)
| An object has been changed or added by this plugin. More...
virtual void | nodeVisibilityChanged (int _identifier)
| A scenegraph node has been shown or hidden. More...
virtual void | getCurrentRenderer (unsigned int _viewer, QString &_rendererName)
| Get the current renderer for the given viewer. More...
Private Member Functions inherited from TypeInterface
virtual | ~TypeInterface ()
| Destructor.
Private Member Functions inherited from LoggingInterface
virtual | ~LoggingInterface ()
| Destructor.
Private Member Functions inherited from LoadSaveInterface
virtual | ~LoadSaveInterface ()
| Destructor.
virtual void | addEmptyObject (DataType _type, int &_id)
virtual void | copyObject (int _oldId, int &_newId)
virtual void | emptyObjectAdded (int _id)
| DEPRECATED HERE (Moved to Type Interface)! Emit this signal if an empty object has been created. More...
virtual void | deleteObject (int _id)
| Delete an object This signal can be called from any thread. . More...
virtual void | deleteAllObjects ()
| Delete all Objects. More...
virtual void | getAllFileFilters (QStringList &_filters)
| Get all file filters that are registered. More...
Private Member Functions inherited from ContextMenuInterface
virtual | ~ContextMenuInterface ()
| Destructor.
virtual void | addContextMenuItem (QAction *_action, DataType _objectType, ContextMenuType _type)
| Add an entry for a context Menu. More...
virtual void | hideContextMenu ()
| hide the main context menu

## Private Attributes
QAction * | renderControlNetAction_
| Context menu action.
QAction * | renderSurfaceAction_
| Context menu action.
QAction * | renderCPSelectionAction_
| Context menu action (render selection texture)
QAction * | renderKnotSelectionAction_
QAction * | renderNoSelectionAction_

## Detailed Description

Definition at line 70 of file TypeBSplineSurface.hh.

## Member Function Documentation

## ◆ addEmpty()

int TypeBSplineSurfacePlugin::addEmpty | ( |  | ) |
| virtual

Create an empty object.

When this slot is called you have to create an object of your supported type.

Returns
  Id of the new Object

Implements TypeInterface.

Definition at line 254 of file TypeBSplineSurface.cc.

## ◆ description()

QString TypeBSplineSurfacePlugin::description | ( |  | ) |
| inline virtual

Return a description of what the plugin is doing.

This function has to return a basic description of the plugin

Implements BaseInterface.

Definition at line 120 of file TypeBSplineSurface.hh.

## ◆ name()

QString TypeBSplineSurfacePlugin::name | ( |  | ) |
| inline virtual

Return a name for the plugin.

This Function has to return the name of the plugin.

Implements BaseInterface.

Definition at line 119 of file TypeBSplineSurface.hh.

## ◆ pluginsInitialized

void TypeBSplineSurfacePlugin::pluginsInitialized | ( |  | ) |
| private slot

Second initialization phase.

Definition at line 67 of file TypeBSplineSurface.cc.

## ◆ slotUpdateContextMenu()

void TypeBSplineSurfacePlugin::slotUpdateContextMenu | ( | int | _objectId | ) |
| private virtual

When the main application requests a context menu, this slot is called before showing the window. If an object is picked the id will be given in this call so you can change the contents of your menu depending on the given object.

Parameters

  _objectId | id of the object

Reimplemented from ContextMenuInterface.

Definition at line 135 of file TypeBSplineSurface.cc.

## ◆ supportedType()

DataType TypeBSplineSurfacePlugin::supportedType | ( |  | ) |
| virtual

Return your supported object type( e.g. DATA_TRIANGLE_MESH )

The function is used from addEmpty in the core to check if your plugin can create an object of a given dataType. If so, your addEmpty function will be invoked to create it.

Implements TypeInterface.

Definition at line 244 of file TypeBSplineSurface.cc.

The documentation for this class was generated from the following files:

- Type-BSpline/Plugin-TypeBSplineSurface/TypeBSplineSurface.hh
- Type-BSpline/Plugin-TypeBSplineSurface/TypeBSplineSurface.cc